/*
 * NetPrint by Michal Vanka
 * Compile with Borland C++ Builder 1.0 or better
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include <winsock.h>  // Needed for Windows Sockets
#include <process.h>  // Needed for Thread's
#include <stdio.h>

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma link "numedit"
#pragma resource "*.dfm"
TForm1 *Form1;
char txt[200];
void __fastcall ErrMes(String S);
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
SOCKET GlobalSocket;

void receive_thread(void * passedThread);

typedef unsigned char uchar;
void __fastcall ErrMes(String S);

#define LISTENING 1
#define LBLOCK 2
#define STOP 4

int volatile flags=0;

void __fastcall TForm1::cbListenClick(TObject *Sender)
{
//
   	static int t;
    if(cbListen->Checked) {
        if(!(flags&LISTENING)) {
            Init();
            flags|=LISTENING;
            _beginthread(receive_thread,0,&t);
        }
    }
    else {
        flags|=STOP;  //signalize stop to the receiving thread
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnClearClick(TObject *Sender)
{
    while(flags&LBLOCK);
    flags|=LBLOCK;
    lb1->Items->Clear();
    flags&=~LBLOCK;
}
//---------------------------------------------------------------------------
void receive_thread(void * passedThread)
{
    #define BUFSIZE 1600
    char buffer[BUFSIZE+1];
	char txt[100];
    unsigned char *p;
    int i=0;

	SOCKADDR_IN remote_sockaddr_in;
	unsigned long remote_sockaddr_length = sizeof(SOCKADDR_IN);

    fd_set fdset;
    struct timeval tv;

    remote_sockaddr_in.sin_family=AF_INET;
    remote_sockaddr_in.sin_port=htons(2001);
    remote_sockaddr_in.sin_addr.s_addr=INADDR_ANY;

	tv.tv_sec=0;
    tv.tv_usec=50000;  //timeout for checking stop flag (select() can't wait infinitely)

    while(1) {
	    int s;
	    FD_ZERO(&fdset);
	    FD_SET(GlobalSocket,&fdset);
//        if(!Form1->cbListen->Checked) { //second possibility for checking for stop
        if(flags&STOP) {
            closesocket(GlobalSocket);
            flags&=~LISTENING;
            flags&=~STOP;
            _endthread();
        }
	    if((s=select(FD_SETSIZE,&fdset,0,0,&tv))<0) {  //select error
        	continue;
        }
        if(!s) continue; //timeout
		if(!FD_ISSET(GlobalSocket,&fdset)) {
		   	ErrMes("Socket error.");
	        continue;
        }
		if(SOCKET_ERROR==recvfrom(GlobalSocket,buffer,sizeof(buffer),(int)NULL,(SOCKADDR *)&remote_sockaddr_in,(int *)&remote_sockaddr_length)) {
	    	//error
	        sprintf(txt, "recvfrom() failed: %d", WSAGetLastError());
   			ErrMes(txt);
        	continue;
    	}
        p=buffer;
        for(int i=0;i<BUFSIZE;i++) {
            if(*p<' ') { *p=0; break; }
            ++p;
        }
        while(flags&LBLOCK);
        flags|=LBLOCK;
        if(Form1->neCycle->Value) {
            if(Form1->lb1->Items->Count==Form1->neCycle->Value) {
                Form1->lb1->Items->Clear();
            }
        }
        Form1->lb1->Items->Add(buffer);
        Form1->lb1->ItemIndex=Form1->lb1->Items->Count-1;
        flags&=~LBLOCK;
	}
}
//--------------------------------------------------------------
void __fastcall TForm1::Init(void)
{
	static int  rThread = 0;      // Thread - must be static
	SOCKADDR_IN localsin;		  // Local "Internet" Socket Address Structure
    char b[60];

    GlobalSocket = socket(AF_INET, SOCK_DGRAM, 0); // UDP Type

    if (GlobalSocket == INVALID_SOCKET)
    {
		ErrMes("Socket Failed");
            closesocket(GlobalSocket);
            return;
    }

    localsin.sin_family = AF_INET;
    localsin.sin_addr.s_addr = INADDR_ANY;
    localsin.sin_port = htons(nePort->Value);

    if(bind(GlobalSocket,(SOCKADDR *)&localsin, sizeof(SOCKADDR_IN)) == SOCKET_ERROR) {
          sprintf(b, "bind failed: %d", WSAGetLastError());
          ErrMes(b);
          return;
    }
}

void __fastcall TForm1::FormCreate(TObject *Sender)
{
//
    WSADATA localWSA;
    char b[60];
    int status;

    if((status=WSAStartup(MAKEWORD(1,1),&localWSA))) {
         sprintf(b, "Error trying to load WINSOCK DLL: %d", status);
         ErrMes(b);
    }
}
void __fastcall ErrMes(String S)
{
	Application->MessageBox(S.c_str(),"Error",MB_OK|MB_ICONERROR);
}

//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
	flags|=STOP;  //signalize stop to the receiving thread
    Sleep(200);  //give the receiving thread chance to exit
//
}
//---------------------------------------------------------------------------